//--------------------------------------------------------------------
extern int     TimeFrame            = 0;
extern int     HMA_Period           = 20;
extern int     HMA_PriceType        = 0;
extern int     HMA_Method           = 3;
extern bool    NormalizeValues      = TRUE;
extern int     NormalizeDigitsPlus  = 2;
extern int     VerticalShift        = 0;


extern int     Stoploss             = 0,           //
               Takeprofit           = 0,           //
               TrailingStop         = 0,           //,  0,   
               NoLoss               = 0,           //  ,  0,     
               MaxOrders            = 1;           // -    
extern double  Lot                  = 0.1,         // Lot=0,      
               risk                 = 10;          //      
extern bool    CloseRevers          = true;        //    
extern int     Magic                = 1234567890;
extern bool    Cycle                = true;
//--------------------------------------------------------------------
int TimeBar,STOPLEVEL;
int last_signal=-1;

//--------------------------------------------------------------------
void init() {
   if(Cycle) start();
   }
//--------------------------------------------------------------------
int start() {
   while(!IsStopped()) {
   RefreshRates();
   
   
   int Ticket,STOPLEVEL=MarketInfo(Symbol(),MODE_STOPLEVEL),b,s,tip;
   double OSL,OTP,OOP,StLo,SL,TP;
   for (int i=0; i<OrdersTotal(); i++)
   {    
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         { 
            tip = OrderType(); 
            if (tip<2)
            {
               OSL   = NormalizeDouble(OrderStopLoss(),Digits);
               OTP   = NormalizeDouble(OrderTakeProfit(),Digits);
               OOP   = NormalizeDouble(OrderOpenPrice(),Digits);
               Ticket = OrderTicket();
               SL=0;TP=0;
               if (tip==OP_BUY)             
               {
                  b++;
                  if (OSL==0 && Stoploss>=STOPLEVEL && Stoploss!=0)
                  {
                     SL = NormalizeDouble(Bid - Stoploss   * Point,Digits);
                  } 
                  else SL=OSL;
                  if (OTP==0 && Takeprofit>=STOPLEVEL && Takeprofit!=0)
                  {
                     TP = NormalizeDouble(Ask + Takeprofit * Point,Digits);
                  } 
                  else TP=OTP;
                  if (NoLoss>=STOPLEVEL && OSL<OOP && NoLoss!=0)
                  {
                     if (OOP <= NormalizeDouble(Bid-NoLoss*Point,Digits)) SL = OOP;
                  }
                  if (TrailingStop>=STOPLEVEL && TrailingStop!=0)
                  {
                     StLo = NormalizeDouble(Bid-TrailingStop*Point,Digits);
                     if (StLo >= OOP && StLo <= NormalizeDouble(Bid-STOPLEVEL*Point,Digits) && StLo > OSL) SL = StLo;
                  }
                  if (SL != OSL || TP != OTP)
                  {  
                     if (!OrderModify(Ticket,OOP,SL,TP,0,White)) Print("Error order ",Ticket);
                  }
               }                                         
               if (tip==OP_SELL)        
               {
                  s++;
                  if (OSL==0 && Stoploss>=STOPLEVEL && Stoploss!=0)
                  {
                     SL = NormalizeDouble(Ask + Stoploss   * Point,Digits);
                  }
                  else SL=OSL;
                  if (OTP==0 && Takeprofit>=STOPLEVEL && Takeprofit!=0)
                  {
                     TP = NormalizeDouble(Bid - Takeprofit * Point,Digits);
                  }
                  else TP=OTP;
                  if (NoLoss>=STOPLEVEL && (OSL>OOP || OSL) && NoLoss!=0)
                  {
                     if (OOP >= NormalizeDouble(Ask+NoLoss*Point,Digits)) SL = OOP;
                  }
                  if (TrailingStop>=STOPLEVEL && TrailingStop!=0)
                  {
                     StLo = NormalizeDouble(Ask+TrailingStop*Point,Digits);
                     if (StLo <= OOP && StLo >= NormalizeDouble(Ask+STOPLEVEL*Point,Digits) && (StLo < OSL || OSL==0)) SL = StLo;
                  }
                  if (SL != OSL || TP != OTP)
                  {  
                     if (!OrderModify(Ticket,OOP,SL,TP,0,White)) Print("Error order ",Ticket);
                  }
               } 
            }
         }
      }
   } 
   if (TimeBar==Time[0]) return(0);
   
   
      double   buf_1_now=iCustom(Symbol(),TimeFrame,"HMA Color",HMA_Period, HMA_PriceType, HMA_Method, NormalizeValues, NormalizeDigitsPlus, VerticalShift,1,1);
      double   buf_3_now=iCustom(Symbol(),TimeFrame,"HMA Color",HMA_Period, HMA_PriceType, HMA_Method, NormalizeValues, NormalizeDigitsPlus, VerticalShift,3,1);
      double   buf_1_last=iCustom(Symbol(),TimeFrame,"HMA Color",HMA_Period, HMA_PriceType, HMA_Method, NormalizeValues, NormalizeDigitsPlus, VerticalShift,1,2);
      double   buf_3_last=iCustom(Symbol(),TimeFrame,"HMA Color",HMA_Period, HMA_PriceType, HMA_Method, NormalizeValues, NormalizeDigitsPlus, VerticalShift,3,2);
      int signal=-1;
      if(buf_1_now==buf_3_now) {
         if(buf_1_last<Ask*2) {
            signal=1;
            last_signal=1;
            }
         if(buf_3_last<Ask*2) {
            signal=0;
            last_signal=0;
            }
         }
      if(buf_1_now!=buf_3_now) {
         if(buf_1_now<Ask*2 && last_signal==1) {
            signal=0;
            last_signal=0;
            }
         if(buf_3_now<Ask*2 && last_signal==0) {
            signal=1;
            last_signal=1;
            }
         }

         
         
      /*
      if(buf_1_last==buf_3_last) {
         if(buf_1_now<Ask*2) signal=0;
         if(buf_3_now<Ask*2) signal=1;
         }
      */
      
   if (signal==0)
   {
      if (CloseRevers) CLOSEORDER(OP_SELL);
      if (MaxOrders>b)       
      {
         if (OrderSend(Symbol(),OP_BUY, LOT(),NormalizeDouble(Ask,Digits),2,0,0," ",Magic,3)!=-1) TimeBar=Time[0]; 
         else Print("OrderSend BUY Error ",GetLastError(),"  SL ",SL,"  TP ",TP);
      }
   }
   if (signal==1)
   {
      if (CloseRevers) CLOSEORDER(OP_BUY);
      if (MaxOrders>s) 
      {
         if (OrderSend(Symbol(),OP_SELL,LOT(),NormalizeDouble(Bid,Digits),2,0,0," ",Magic,3)!=-1) TimeBar=Time[0]; 
         else Print("OrderSend SELL Error ",GetLastError(),"  SL ",SL,"  TP ",TP);
      }
   }
   
   if(!Cycle) break;
   Sleep(100);   
   }      

return(0);
}
//--------------------------------------------------------------------
void CLOSEORDER(int ord)
{
   for (int i=0; i<OrdersTotal(); i++)
   {                                               
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         {
            if (OrderType()==OP_BUY && ord==OP_BUY)
               OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Bid,Digits),3,CLR_NONE);
            if (OrderType()==OP_SELL && ord==OP_SELL)
               OrderClose(OrderTicket(),OrderLots(),NormalizeDouble(Ask,Digits),3,CLR_NONE);
         }
      }   
   }
}
//--------------------------------------------------------------------
double LOT()
{
   if (Lot!=0) return(Lot);
   double MINLOT = MarketInfo(Symbol(),MODE_MINLOT);
   double LOT = AccountFreeMargin()*risk/100/MarketInfo(Symbol(),MODE_MARGINREQUIRED);
   if (LOT>MarketInfo(Symbol(),MODE_MAXLOT)) LOT = MarketInfo(Symbol(),MODE_MAXLOT);
   if (LOT<MINLOT) LOT = MINLOT;
   if (MINLOT<0.1) LOT = NormalizeDouble(LOT,2); else LOT = NormalizeDouble(LOT,1);
   return(LOT);
}
//--------------------------------------------------------------------

